package com.ruoyi.sim.controller;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.sim.domain.Fault;
import com.ruoyi.sim.domain.RealExam;
import com.ruoyi.sim.domain.Seat;
import com.ruoyi.sim.domain.vo.SimSocketParamVo;
import com.ruoyi.sim.service.impl.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/sim/iot")
@Api("测试通信Controller")
public class TestIotController extends BaseController {

    @Autowired
    @Lazy
    private CommSendService commSendService;
    @Autowired
    @Lazy
    private RealExamService realExamService;
    @Autowired
    @Lazy
    private FaultService faultService;
    @Autowired
    @Lazy
    private SocketService socketService;
    @Autowired
    @Lazy
    private CommCheckService commCheckService;
    @Autowired
    @Lazy
    private SeatService seatService;

    @ApiOperation("debug666")
    @GetMapping(value = "/{codeId}")
    public AjaxResult testIndex(@PathVariable("codeId") Integer codeId) {
        long examId = 2L;
        switch (codeId) {
            case 6: {
                RealExam re = realExamService.selectRealExamByExamId(1L);
                commSendService.clearOneSimAllFaultByExam(re);
            }
            break;
            case 10: {
                commSendService.clearAll();
                RealExam re = realExamService.selectRealExamByExamId(1L);
                commSendService.clearOneSimAllFaultByExam(re);
            }
            break;
            case 11: {
                commSendService.readAll();
            }
            break;
            case 12: {
                RealExam re = realExamService.selectRealExamByExamId(1L);
                commSendService.readOneExamAtLast(re);
                //
            }
            break;
            case 20: {
                realExamService.studentEnterRealExam(examId);
                //
            }
            break;
            case 21: {
                realExamService.studentLoopPrepareRealExam(examId);
                //
            }
            break;
            case 23: {
                realExamService.studentLoopAnsweringRealExam(examId);
                //
            }
            break;
            case 24: {
                realExamService.studentSubmitRealExam(examId, null, null);
                //
            }
            break;
            case 25: {
                realExamService.studentLoopPostRealExam(examId);
                //
            }
            case 26: {
                AjaxResult aj = socketService.tryOpenAll();
                return aj;
            }
            case 27: {
                // socketService.closeOne(new SimSocketVo("192.168.1.202", 33301));

                socketService.openOne(new SimSocketParamVo(SocketService.IP_TEST, SocketService.PORT_TEST), true);
                // socketService.closeOne(new SimSocketVo("192.168.1.202", 11008));
            }
            case 100: {
                return socketService.tryOpenAll();
            }
            case 101: {
                Seat seat = seatService.selectSeatBySeatId(10L);
                return commCheckService.checkOneSeatState(seat, true);
            }
            case 102: {
                return commCheckService.checkAllSeatAndSimState();
            }
            case 200: {
                String ip = "192.168.1.201";
                return commCheckService.checkPingRs485State(ip);
            }
        }
        return AjaxResult.success("ZZZZZZZZZZZZZZZZZZZZ");
    }

    @ApiOperation("testIot通信")
    @GetMapping(value = "/testIndex2/{codeId}")
    public AjaxResult testIndex2(@PathVariable("codeId") Integer codeId) {
        List<Fault> list = faultService.randomEnable3("0001");
        return AjaxResult.success(list);
    }
}
